/******************************************************************
 *	USART MW[
 ******************************************************************
 *	
 *	{[[gݒ (U2Xgp)
static	void cmdBaud(uchar brrl,uchar brrh,uchar csrc);
==			 USART_init(uchar brrl,uchar brrh,uchar csrc);
 *
 *	qrQRQbMf[^FIFO擾.
static	void USART_RecvData(uchar *result,uchar txack);
 *
 *	qrQRQbM^XN.
static	void USART_RecvTask(void);
static	void USART_SendTask(void);
 *	
 *	
 */


/******************************************************************
 *	
 ******************************************************************
 */
#define FOSC 12000000         	/* MCUNbNg */
#define BAUD 9600             	/* ړIUSART{[[gx */
#define MYUBRR FOSC/16/BAUD-1 	/* ړIUBRRl */

#define	TXBUF_SIZE	4			// Mobt@TCY. 4Ɍ.
#define	RXBUF_SIZE	32			// MFIFOTCY.

static uchar rsbuf[TXBUF_SIZE];	// qrQRQbMobt@.
static uchar rsptr=TXBUF_SIZE;	// on_ (0..3) A4 ̎͋.

uchar USART_rxbuf[RXBUF_SIZE];	// MFIFO.
uchar USART_rxptr =0;			// FIFOݒn_.
uchar USART_getptr=0;			// FIFOon_.

#if	0
//	ȉAU2X=1̂Ƃ. (vXP[[=1/8)
#define	USART_default_baud 624,0,0x0e	//   2400,8N2
#define	USART_default_baud 311,0,0x0e	//   4800,8N2
#define	USART_default_baud 155,0,0x0e	//   9600,8N2
#define	USART_default_baud  77,0,0x0e	//  19200,8N2
#define	USART_default_baud  38,0,0x0e	//  38400,8N2
#define	USART_default_baud  25,0,0x0e	//  57600,8N2
#define	USART_default_baud  18,0,0x0e	//  76800,8N2
#define	USART_default_baud  12,0,0x0e	// 115200,8N2
#define	USART_default_baud   5,0,0x0e	// 250000,8N2
#define	USART_default_baud   4,0,0x0e	// 375000,8N2
#define	USART_default_baud   3,0,0x0e	// 400000,8N2
#define	USART_default_baud   2,0,0x0e	// 500000,8N2
#define	USART_default_baud   1,0,0x0e	// 750000,8N2
#define	USART_default_baud   0,0,0x0e	//1500000,8N2
//
// :|[OM̎葬ƕ̎肱ڂ܂.
//
#endif

#define	USART_default_baud 155,0,0x0e	//   9600,8N2

/******************************************************************
 *	{[[gݒ.
 *  : uchar param[3];
 *              param[0] = {[[gݒ背WX^.
 *              param[1] = {[[gݒ背WX^.
 *              param[2] = t[ݒ背WX^.
 ******************************************************************
 */
static void cmdBaud(uchar brrl,uchar brrh,uchar csrc)
{
	UBRRH = brrh; 		/* ްڰĐݒ(޲) */
	UBRRL = brrl;     	/* ްڰĐݒ(޲) */
	UCSRC = csrc;		/* ڰь`ݒ(8ޯ,2į ޯ) */
	UCSRB = (1<<RXEN)|(1<<TXEN);      /* M */
	UCSRA = (1<<U2X);	// vXP[ 1/16  1/8 ɕύX.
}

/******************************************************************
 *	tr`qs̏.
 ******************************************************************
 */
#define	USART_Init	cmdBaud


#if	0
void USART_Init(unsigned int baud)
{
	UBRRH = (unsigned char)(baud>>8); /* ްڰĐݒ(޲) */
	UBRRL = (unsigned char) baud;     /* ްڰĐݒ(޲) */
	UCSRC = (1<<USBS)|(3<<UCSZ0);     /* ڰь`ݒ(8ޯ,2į ޯ) */
	UCSRB = (1<<RXEN)|(1<<TXEN);      /* M */
//	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);      /* M,M荞 */
}
#endif
/******************************************************************
 *	qrQRQbM荞݃nh[.
 ******************************************************************
 */
#if	USE_USART_RX_INTERRUPT

//	̂ƂgC͂܂B

SIGNAL(USART_RX_vect)
{
	uchar rxchr = UDR;          							/* Mް擾 */
//	sei();
	USART_rxbuf[USART_rxptr] = rxchr;
	USART_rxptr++;
	if(	USART_rxptr >= RXBUF_SIZE) {				// obt@.
		USART_rxptr = 0;
	}
}

#endif
/******************************************************************
 *	qrQRQbMf[^擾.
 ******************************************************************
    MFIFO USART_rxbuf[] 
 */
static int USART_RecvData(uchar *result,uchar txack)
{
	uchar n = USART_getptr;					// FIFO̎o|C^.
	uchar i;
	for(i=1;i<MAX_RXPACKET;i++) {
		if( n == USART_rxptr ) break;		// FIFÕgbvɒǂ.
		result[i] = USART_rxbuf[n];			// MRs[.
		n++;
		if(	n >= RXBUF_SIZE) {				// obt@.
			n = 0;
		}
	}
	USART_getptr = n;
	result[0] = (i-1) | txack;
	return i;
}

#if	0
static void USART_Flush(void)
{
     unsigned char dummy;     						/* ꎞϐ` */
     while ( !(UCSRA & (1<<RXC)) ) dummy=UDR;     	/* ްǂݎ̂ */
}
#endif
/******************************************************************
 *	qrQRQbM^XN.
 ******************************************************************
 */

static void USART_RecvTask(void)
{
	while( UCSRA & (1<<RXC) ) {					// MH .
		uchar rxchr = UDR;    					// Mf[^擾.
		uchar n = USART_rxptr;					// FIFȌ݃|C^.
		USART_rxbuf[n] = rxchr;
		n++;
		if(	n >= RXBUF_SIZE) {
			n = 0;
		}

		// FIFOo|C^ɒǂA|C^XVȂ.
		if(n != USART_getptr) {
			USART_rxptr = n;
		}
	}
}

/******************************************************************
 *	qrQRQbM^XN.
 ******************************************************************
 */
static void USART_SendTask(void)
{
	if(	rsptr < TXBUF_SIZE) {	//Mobt@Ƀf[^cĂȂ,
		//
		//	PMs.
		//
		if ( !(UCSRA & (1<<UDRE)) ) return;	/* Mޯ̧󂫑ҋ@ */
	    UDR = rsbuf[rsptr];     			/* M */
		rsptr++;	//|C^i߂.
	}
}

/******************************************************************
 *	
 ******************************************************************
 */
